"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class MemoryLayer {
    constructor(options = {}) {
        this._map = new Map();
        this._options = Object.assign({}, options);
        if (options.map) {
            this._map = options.map;
        }
    }
    get map() {
        return this._map;
    }
    async batchGet(keys) {
        return keys.map(key => {
            var _a, _b, _c;
            const cacheKey = (_c = (_b = (_a = this._options).keyFn) === null || _b === void 0 ? void 0 : _b.call(_a, key), (_c !== null && _c !== void 0 ? _c : key));
            const value = this._map.get(cacheKey);
            if (!value) {
                return new Error(`No cache value of key: ${key}`);
            }
            return value;
        });
    }
    async batchSet(map) {
        map.forEach((value, key) => {
            var _a, _b, _c;
            const cacheKey = (_c = (_b = (_a = this._options).keyFn) === null || _b === void 0 ? void 0 : _b.call(_a, key), (_c !== null && _c !== void 0 ? _c : key));
            this._map.set(cacheKey, value);
        });
    }
}
exports.default = MemoryLayer;
//# sourceMappingURL=MemoryLayer.js.map